package example;
import java.util.Arrays;
/*Design and create a menu-driven program which allows a user to enter at most 50 students� scores for a subject 
  and displays variety of information based on the user selection. 
The minimum requirements of this program are as follow: 
- Be able to display menu which contains at least 5 alternatives.
- Be able to accept student name and total score.
- Be able to display a score of a particular student. (search score by using student name as a key)
- Be able to compute and display mean, median and mode of the whole scores.
- Be able to list all student names who get score higher than the mean(average).
- Contains at least 4 methods/functions. */

//ID:5913929  Name:Qianheng Ma
import java.util.Scanner;
public class lasthomework {
	public static void displayMenu(){
		System.out.println("****************Menu Example****************");
		System.out.println("Press 1 to >>>>>>>>>>>>>Display a score of a particular student");
		System.out.println("Press 2 to >>>>>>>>>>>>>Compute and display mean, median");
		System.out.println("Press 3 to >>>>>>>>>>>>>Mode of the whole scores");
		System.out.println("Press 4 to >>>>>>>>>>>>>List all student names who get score higher than the mean(average)");
		System.out.println("Press 5 to Exit!!!");
		}	
	
	public static void displayList(String[] name,double[] score){
		
		System.out.println("Name    Score");
		for(int i = 0; i<name.length;i++){
			System.out.println(name[i]+"\t"+score[i]);
			}
	}
	
	public static int seqSearch(String[] name, String key){
		int met = -1;
		for (int i =0; i <name.length; i++)
			if (name[i].equals(key)){
				met = i;
				break;
			}
		return met;
	}
	
	public static void mode(double [] stscore){
		Arrays.sort(stscore);
		int count=1;
		int longest =0;
		double mode = 0;
		for(int i=0;i<stscore.length-1;i++){
		if(stscore[i]==stscore[i+1]){
		  count++;
			}
		  else{
			  count = 1;
		  }
		if(count>longest){
			  mode = stscore[i];
			  longest = count;
		  }
			}
		System.out.println("The mode of the whole scores is "+mode);
	}
	
	public static void main(String[] args){
		Scanner in = new Scanner(System.in);
		int choice = 0;		
		System.out.println("How many students? ");
		int num= in.nextInt();
		String[] stName = new String[num];
		double[] stScore = new double[num];
		//int index = seqSearch(stName, "John");
	String temp =in.nextLine();
	for(int i = 0;i<num;i++){
		System.out.println("Name: ");
		stName [i] = in.nextLine();
		System.out.println("Scaore : ");
		stScore [i] = in.nextInt();
		temp = in.nextLine();
	}
	displayList(stName,stScore);
	do{
		displayMenu();
		System.out.println("Select a choice: ");
		choice = in.nextInt();
	if(choice==1)
		{
		System.out.println("Enter the name of a student you want to know his score===> ");
		String s = in.nextLine();
		String sName = in.nextLine();
		int index = seqSearch(stName,sName);
		if (index != -1){
				System.out.println(stName[index]+" get the score "+stScore[index]);
			}else{
				System.out.println("Not found!");
				}
		}
		else if(choice==2){
				int sum = 0;
				for(int n = 0; n<stName.length; n++){
				   sum += stScore[n];
				  }
					int mean = 0;
				   mean = sum/num;
				   System.out.println("The mean is "+mean);
				   Arrays.sort(stScore);
				   double median =0;
				   if(stScore.length%2==0)
				   median = (stScore[stScore.length/2]+stScore[stScore.length/2-1])/2;
				   else
				   median = stScore[stScore.length/2];
				   System.out.println("The median is "+median);
				   }
		if(choice==3){
			mode(stScore);
		}
		else if(choice==4){
			int sum = 0;
				for(int n = 0; n<stName.length; n++){
				   sum += stScore[n];
				  }
					int mean = 0;
				   mean = sum/num;
				   System.out.print("All students names who get score higher than the mean(average) :");
			for(int i =0;i<num;i++){
				if(stScore[i]>mean){
					System.out.print(stName[i]+" ");
				}
			}System.out.println("");
		}
		}while (choice!=5);
		System.out.println("Bye");
		in.close();
		}
}